/*
The DsTool program is the property of:
 
                             Cornell University 
                        Center of Applied Mathematics 
                              Ithaca, NY 14853
                      dstool_bugs@macomb.tn.cornell.edu
 
and may be used, modified and distributed freely, subject to the following
restrictions:
 
       Any product which incorporates source code from the DsTool
       program or utilities, in whole or in part, is distributed
       with a copy of that source code, including this notice. You
       must give the recipients all the rights that you have with
       respect to the use of this software. Modifications of the
       software must carry prominent notices stating who changed
       the files and the date of any change.
 
DsTool is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of FITNESS FOR A PARTICULAR PURPOSE.
The software is provided as is without any obligation on the part of Cornell 
faculty, staff or students to assist in its use, correction, modification or
enhancement.
*/

/*
 * fixed_local.h
 */

#ifndef FIXED_LOCAL_h
#define FIXED_LOCAL_h


/* fixed_install.c */
/* fp_init.c */
/* fp_get_atts.c */



/* fp_1dman.c */
int fp_1dman( struct Fixpt_DataS* fp);

/* fp_compute.c */
int fp_compute( struct Fixpt_DataS* fp);

/* fp_eval.c */
int fp_eval( struct Fixpt_DataS* fp);

/* fp_get_type.c */
void fp_get_type( struct Fixpt_DataS* fp);

/* fp_jac.c */
int fp_jac( struct Fixpt_DataS* fp, int fd_flag);

/* mnewt.c */
int mnewt(struct Fixpt_DataS* fp);

/* msecant.c */
int msecant(struct Fixpt_DataS* fp);

/* trkman_map.c */
int trkman_map( struct Fixpt_DataS* fp);

/* trkman_ode.c */
int trkman_ode( struct Fixpt_DataS* fp);

#endif /* FIXED_LOCAL_h */

